﻿-- Crowd Control module

function SN:CrowdCtrl()
	local f = SN.F
	local m = SN.Media
	--make the frames db local
	local v = SN.db.profile.Frames
	
	f.cc = SN:MakeFrame("CCGroup", "crowdcontrol", "SN:arg4", 20)
	f.cc:SetScript("OnEvent", function(self, event, ...)
		SN:UpdateCC(self, event, ...)
	end)
	f.cc:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	f.cc:RegisterEvent("UNIT_AURA")
end

function SN:UpdateCC(frame, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local _, type, _, sourceGUID, sourceName, _, _, destGUID, destName = ...
		local spellID, spellName = select(12, ...)
			
		if type == "SPELL_CAST_SUCCESS" then
			--Cycle through our cooldown list
			for i, cooldown in pairs(SN.db.profile.crowdcontrol) do
				if spellId == cooldown[1] then
					--Check to see if the cc is a from a group member
					if UnitInParty(sourceName) or UnitInRaid(sourceName) then
						SN:CreateBar(self, cooldown[1], cooldown[2], destName, destGUID, spellName)
					--Send the raid CD to see if it's supposed to be announced.
						SN:AnnounceCD(cooldown[2], spellId, sourceName)
					end
				end
			end
		end
		if type == "SPELL_AURA_APPLIED" then
			if sourceGUID == UnitGUID("player") and not destGUID == UnitGUID("player") then
				for i, cooldown in pairs(SN.db.profile.crowdcontrol) do
					if spellId == cooldown[1] then
					--Check to see if the cc is a from a group member
						if UnitPlayerOrPetInRaid(sourceName) or UnitPlayerOrPetInParty(sourceName) then
							SN:CreateBar(self, cooldown[1], cooldown[2], destName, destGUID, spellName)
						--Send the raid CD to see if it's supposed to be announced.
							SN:AnnounceCD(cooldown[2], spellId, sourceName)
						end
					end
				end
			end
		end
		if type == "SPELL_AURA_REFRESH" then
			local tempbar = SN:Find(self, "SN:arg5", spellName)
			if tempbar ~= nil then
				for i, cooldown in pairs(SN.db.profile.crowdcontrol) do
					if spellId == cooldown[1] then
						tempbar:SetDuration(cooldown[2])
						tempbar:Start()
					end
				end
			else
				for i, cooldown in pairs(SN.db.profile.crowdcontrol) do
					if spellId == cooldown[1] then
						--Start a new one because there wasn't
						SN:CreateBar(self, spellId, cooldown[2], destName, destGUID, spellName)
					end
				end
			end
		end
		if type == "SPELL_AURA_REMOVED" or type == "SPELL_AURA_DISPELLED" then 
			local tempbar = SN:Find(self, "SN:arg3", destGUID)
			if tempbar ~= nil then
				tempbar:Stop()
			end
		end
	end
	if event == "UNIT_AURA" then

	end
end

function IsUnitPlayer(guid) 
	local guid = strsub(guid, 1 ,5)
	if(bit.band(guid, 0x00F) == 0) then 
		return true
	end
	return false
end

function RaidIcon() 
	for i, 
	local Target_RaidIcon = GetRaidTargetIndex("target");
	if(Target_RaidIcon) then 
		return(Afterlife_RaidMarks[Target_RaidIcon]);
	else 
		return(Afterlife_RaidMarks[9]); 
	end;

